#include <opencv2/core.hpp>
#include <opencv2/imgcodecs.hpp>
#include <opencv2/highgui.hpp>

#include <iostream>
#include <string>

using namespace cv;
using namespace std;

int main( int argc, char **argv ) {
    if ( argc != 2 ) {
       printf( "Usage: display_image ImageToLoadAndDisplay\n" );
       return -1;
    }

    cv::Mat image = cv::imread( argv[1] ); /* Read the file */

    if ( !image.data ) { /* Check for invalid input */
        printf("Could not open or find the image\n") ;
        return -1;
    }

    cv::namedWindow( "Display window"  ); /* Create a window for display */
    cv::imshow( "Display window", image );  /* Show our image inside it */

    cv::waitKey(0);  /* Wait for a keystroke in the window */
    return 0;
}